ENTRY(_start)

MEMORY {
	RAM(rwx) : ORIGIN = 0x00000000, LENGTH = 16K
	ROM(rwx) : ORIGIN = 0xFFFC0000, LENGTH = 256K
}

SECTIONS {

	/* .text 0xFFFC0000 : AT (0xFFFC0000) { */
	.text : {
		_stext = .;
		*(.text)
		*(.text.*)
		. = ALIGN(4);
		_etext = .;
		KEEP(*(.init))
		KEEP(*(.fini))

		PROVIDE(__preinit_array_start = .);
		KEEP(*(.preinit_array))
		PROVIDE(__preinit_array_end = .);
		PROVIDE(__init_array_start = .);
		KEEP(*(.init_array))
		KEEP(*(.init_array.*))
		PROVIDE(__init_array_end = .);
		PROVIDE(__fini_array_start = .);
		KEEP(*(.fini_array))
		KEEP(*(.fini_array.*))
		PROVIDE(__fini_array_end = .);
	} > ROM

	.rodata : {
		. = ALIGN(4);
		*(.rodata)
		*(.rodata.*)
		. = ALIGN(4);
	} > ROM

	_sidata = LOADADDR(.data);
	.data : {
		. = ALIGN(4);
		_sdata = .;

		*(.data)
		*(.data.*)
		. = ALIGN(4);
		_edata = .;
	} > RAM AT > ROM

	.rvectors : {
		_srvectors = .;
		KEEP(*(.rvectors))
	} > ROM

	.fvectors 0xFFFFFF80 : AT(0xFFFFFF80) {
		_sfvectors = .;
		KEEP(*(.fvectors))
	} > ROM

	.istack 0x300 : AT(0x300) {
		. = ALIGN(4);
		_istack = .;
		KEEP(*(.istack))
	} > RAM

	.ustack 0x600 : AT(0x600) {
		. = ALIGN(4);
		_ustack = .;
		KEEP(*(.ustack))
	} > RAM

	.bss : {
		. = ALIGN(4);
		_sbss = .;
		*(.bss)
		*(.bss.*)
		. = ALIGN(4);
		_ebss = .;
		_end = .;
	} > RAM

}
